/**
  * Program to compute word frequencies using architecture-2
  * Input:  Text file named Input
  * Output: Word frequncies
  */


#include<stdio.h>
#define PIPE_LENGTH 2

	FILE 	*fout;
	char 	a[100][10];
	char 	Freq[1000][20];
	int 	Count[1000];
	int 	Mark[1000];

/**
  * This program takes the data from a file and splits it into words
  */

void Splitter()
{
	FILE *fp;

	/**
	  *	Check for exixtance of Input file
	  */

	if ((fp = fopen("InputFile", "r")) == NULL)
	{
	  printf("Error opening file\n");
	  exit(1);
	}
	fout=fopen("OutputFile","w");
	

	//Now read data from file letter by letter and form words
	char ch;
	int i,pipe_count=0;
	char word[20];
	
	while((ch = (char) fgetc(fp)) != EOF )
	{	i=0;
			
		while (ch!=' ' && ch!=EOF)
		{
			word[i++]=ch;			
			ch = (char) fgetc(fp);
		}

		//Increment count of words in pipe
		fprintf(fout,"%s ",word);
		
		if (ch == EOF)
			break;
		
	
	}
	fclose(fp);
	fclose(fout);
}



void swap(int i, int j)
{
	int k;
	char temp[10];

		for(k=0;k<10;k++) {
			temp[k] = a[i][k];
			a[i][k] = a[j][k];
			a[j][k] = temp[k];
		}
}

void Sort(int C)
{
	int i,j;
		for (i=(C-PIPE_LENGTH+1);i<C+1;i++)
		for(j=i+1;j<C+1;j++)
			if (strcmp(a[i],a[j]) > 0) 
			swap(i,j);
}

void printout(int C)
{
	int i;

	for(i=C-PIPE_LENGTH+1;i<=C;i++) 
		fprintf(fout, "%s ",a[i]);
}



void Sorter()
{
	FILE *fp;
	fout=fopen("Output2","w");
	
	/**
	  *	Check for exixtance of Input file
	  */

	if ((fp = fopen("InputFile", "r")) == NULL)
	{
	  printf("Error opening file\n");
	  exit(1);
	}
	
	//Now read data from file letter by letter and form words
	char ch;
	int i,pipe_count=0,current=0;

	
	while((ch = (char) fgetc(fp)) != EOF )
	{	i=0;
			
		while (ch!=' ' && ch!=EOF)
		{
			a[current][i++]=ch;			
			ch = (char) fgetc(fp);
		}

		//Increment count of words in pipe
		pipe_count++;

	
		if(pipe_count == PIPE_LENGTH)
		{
			//Sort the sequence of words
			
			Sort(current);
			printout(current);
			//Send the data to next..component
			pipe_count=0;
			
		}

		current++;		
		if (ch == EOF)
			break;
	
	}
	fclose(fp);fclose(fout);
}

void Counter()
{
	FILE *fp;
	
	/**
	  *	Check for exixtance of Input file
	  */

	if ((fp = fopen("Output2", "r")) == NULL)
	{
	  printf("Error opening file\n");
	  exit(1);
	}
	
	//Now read data from file letter by letter and form words
	char ch;
	int i,pipe_count=0,current=0,fl=0,p,q;
	
	while((ch = (char) fgetc(fp)) != EOF )
	{	i=0;
			
		while (ch!=' ' && ch!=EOF)
		{
			a[current][i++]=ch;			
			ch = (char) fgetc(fp);
		}
		a[current][i]='\0';
		//Increment count of words in pipe
		pipe_count++;
	
			
		if(pipe_count == PIPE_LENGTH)
		{

				for(p=0;p<fl;p++)
				{
					for(q=current-PIPE_LENGTH+1;q<=current;q++)
						if ((strcmp(Freq[p],a[q]))== 0)
								{
								Count[p]++;Mark[q]=1;
							
								}							
				}						
				//Add unmaked entries
				for(q=current-PIPE_LENGTH+1;q<=current;q++)
				{
				if(Mark[q]!=1)
				{
				p=1;
			        strcpy(Freq[fl++],a[q]);

				Mark[q]=1;
				  while (strcmp(a[q],a[q+1]) == 0)
				  {
					  
				    p++;
				    Mark[q+1]=1;
				    q++;
				    }
				      Count[fl-1]=p;

				 }
				 }
			
				pipe_count=0;

			
		}
		current++;		
		if (ch == EOF)
			break;
	
	}

	for(p=0;p<fl;p++)
		printf("Freq of %-20s  is:  %d\n", Freq[p], Count[p]);

	fclose(fp);
}

int main()
{
	Splitter();
	Sorter();
	Counter();	
}
