
/**
  * Program to compute word frequencies using architecture-1
  * Input:  Text file named Input
  * Output: Word frequncies
  */


#include<stdio.h>
#define PIPE_LENGTH 5

char 	buffer[100][20];
char 	Freq[1000][20];
int 	Count[1000];
int 	Mark[1000];

/**
  *	This program takes the data from a file and splits it into words
  */

int main()
{

	FILE 	*fp;
	char 	ch;
	int	pipe_count=0, //maintains pipe count
		current=0,   // keeps track of current word 
		fl=0;	    //
	int 	i,p,q;	   //temporary varibles

	/**
	  *	Check for exixtance of Input file
	  */

	if ((fp = fopen("InputFile", "r")) == NULL)
	{
	  printf("Error opening file\n");
	  exit(1);
	}

	/**
	  *	Now read data from file letter by letter and form words
	  */

	
	while((ch = (char) fgetc(fp)) != EOF )
	{
	
	i=0;
			
		while (ch!=' ' && ch!=EOF)
		{
			buffer[current][i++]=ch;			
			ch = (char) fgetc(fp);
		}
	
		buffer[current][i]='\0';

		//Increment count of words in pipe
		pipe_count++;
	
			
		if(pipe_count == PIPE_LENGTH)
		{
			if(fl==0)
			{
				//add word to list
				strcpy(Freq[0], buffer[current]);
				Count[0]=1;
				fl++;
			}
			else
			{
				for(p=0;p<fl;p++)
				{
					for(q=current-PIPE_LENGTH+1;q<=current;q++)
						if ((strcmp(Freq[p],buffer[q]))== 0)
								{
								Count[p]++;
								Mark[q]=1;
								}								
				}						

				//Add unmarked entries
				for(q=current-PIPE_LENGTH;q<=current;q++)
				{
					if(Mark[q]!=1)
					{
						p=1;
						Mark[q]=1;

				  		while (strcmp(buffer[q],buffer[q+1]) == 0)
				  		{				  
				  			p++;
				    			Mark[q+1]=1;
				    			q++;
				  		}
				    	
						strcpy(Freq[fl++],buffer[q-1]);
				    		Count[fl-1]=p;
				 	}
				 }
			}
  
		pipe_count=0;
	
		}

		current++;
		
		if (ch == EOF)
			break;
	
	}

	for(p=0;p<fl;p++)
		printf("Freq of %-20s  is:  %4d\n", Freq[p], Count[p]);

	fclose(fp);
}
